<template>
    <v-app v-if="" id="navigation-drawer">

        <NavBar v-if="LoggedIn" :store="store"/>
        <ToolBar v-if="LoggedIn" :store="store"/>
        <v-main>
            <router-view :store="store"/>
        </v-main>
    </v-app>
</template>

<script lang="ts">
    import {Component, Vue, Watch} from 'vue-property-decorator';
    import NavBar from './components/NavBar.vue';
    import {auth, coreApi, toaster} from "./init";
    import ToolBar from "./components/ToolBar.vue";
    import {BStorage} from "../../classLibrary/Storage";
    import {Route} from "vue-router";
    import {AlertResponse} from "../../classLibrary/core/alertResponse";
    import moment from "moment-timezone";
    import {Poller} from "../../classLibrary/Poller";
    import {AlertStream, AlertStreamPoller} from "../../classLibrary/Streams/AlertStream";


    @Component({
        components: {
            ToolBar,
            NavBar,
        }
    })
    export default class App extends Vue {


        store: BStorage = new BStorage(
            {
                drawer: false,
                loading: false,
                tz: moment.tz.guess(),
                alerts: [],
            }
        );

        LoggedIn: boolean = auth.LoggedIn;
        first = true;


        alertStreamer?: AlertStream

        poller?: Poller<AlertResponse[]>

        @Watch('$route', {immediate: true, deep: true})
        async onUrlChange(newVal: Route) {
            const prev = this.LoggedIn;
            this.LoggedIn = auth.LoggedIn;
            if (this.LoggedIn && prev != this.LoggedIn) {
                const user = auth.User;
                const password = auth.Password;
                await this.store.UpdateResponse(user, password);
            }
        }


        async created() {
            if (!this.alertStreamer) {
                this.alertStreamer = new AlertStreamPoller(auth, coreApi);
            }
            this.alertStreamer.StartStream(async (alert: AlertResponse) => {
                await toaster.LocalToast({
                    title: alert.title,
                    message: alert.body,
                    type: alert.alertLevel as any
                })
            });
        }

        // async getToast() {
        //
        //     if (auth.LoggedIn && false) {
        //
        //         const user = auth.User;
        //         const password = auth.Password;
        //         const r = await coreApi.Get<AlertResponse[]>(`User/${user}/${password}/alerts`);
        //
        //         if (r.success) {
        //             r.Ok!.Each(x => {
        //
        //             });
        //             await this.store.UpdateResponse(user, password);
        //         }
        //
        //
        //     }
        //     await $$(1000);
        //     this.getToast();
        // }
    }


</script>
